/*
 * Infra Red protocols decoder
 * Author: Piotr Wjtowicz
 * 2016-2017
 * pw@elportal.pl
 */

#include "sircdec.h"

// -----------------------------------------------
void sircPostambleState() {
    TROUT2 (
        RET1, RET0
    );
    sm.productReady = 1;
    sircAddBit(irsm.bitValueTmp);
    sircAddBit(0);
}
// -----------------------------------------------
void sircPreLstate() {
    TROUT3 (
        TR(SIRC_T1, SIRC_EPS, 1, sircH1state),
        RET1, RET0
    );
}
// -----------------------------------------------
void sircL1state() {
    irsm.bitValueTmp = 0;
    sircLstate();
}
// -----------------------------------------------
void sircL2state() {
    irsm.bitValueTmp = 1;
    sircLstate();
}
// -----------------------------------------------
void sircLstate() {
    TROUT3 (
        TR(SIRC_T1, SIRC_EPS, 1, sircH1state),
        TR(MAXT, MAXT, 0, sircPostambleState),
        RET1
    );
    sm.productReady = 1;
}
// -----------------------------------------------
void sircH1state() {
    TROUT4 (
        TR(SIRC_T2, SIRC_EPS, 0, sircL2state),
        TR(SIRC_T1, SIRC_EPS, 0, sircL1state),
        RET0, RET1
    );
    if(sm.productReady) {
        sircAddBit(irsm.bitValueTmp);
        sm.productReady = 0;
    }
}
// -----------------------------------------------
void sircAddBit(uint8_t bitValue) {
    
    irsm.data[irsm.field] >>= 1;
    irsm.data[irsm.field] |= bitValue<<(sircBytesLen[irsm.field]-1);

    if(irsm.bitCounter >= sircBytesLen[irsm.field]-1) {
        irsm.field++;
        irsm.bitCounter = 0;
    } else {
        irsm.bitCounter++;
    }

    if (irsm.field>1) {
        frame_ret.pt = SIRC;
        frame_ret.cmd = irsm.data[0];
        frame_ret.addr = irsm.data[1];
    }

}
