#include <string.h>
#include <stdio.h>
#include <xc.h>
#include <stdint.h>

#include "switch.h"
#include "global.h"

switch_state_t sw_sm;
//------------------------------------------------------------------------------
inline void handle_switch () {
    uint16_t sw_time_temp = sw_sm.state_t;
    

    if (sw_sm.state_t < SW_STATE_MAX)
        sw_sm.state_t++;

    if (PORTAbits.RA4 == 1) {
        if (sw_sm.deb_timer > 0) {
            sw_sm.deb_timer--;
        } else {
            sw_sm.state_s = SWITCH_OFF;
        }
    }
    else
    {
        if (sw_sm.deb_timer < DEBOUNCE_TIME) {
            sw_sm.deb_timer++;
        }
        else {
            sw_sm.state_s = SWITCH_ON;
        }
    }

    main_sm.e &= 0b11110001;
    
    if (sw_sm.before_state_s != sw_sm.state_s) {
        
        if (sw_sm.before_state_s == SWITCH_OFF) {
            main_sm.e = KEY_PRESSED;
        }
        else
        {
            if(sw_sm.eat_pulled_event) {
                sw_sm.eat_pulled_event = 0;
            } else {
                main_sm.e = KEY_PULLED;
            }
        }
        
        sw_sm.state_t = 0;
    }
    sw_sm.before_state_s = sw_sm.state_s;
    
    
    if (sw_sm.before_state_t == LONG_LONG_PRESS - 1) {
        main_sm.e = (sw_sm.state_s == SWITCH_ON) ? KEY_P2 : KEY_OFF2;
    }
    else
    if (sw_sm.before_state_t == LONG_PRESS - 1) {
        main_sm.e = (sw_sm.state_s == SWITCH_ON) ? KEY_P1 : KEY_OFF1;       
    }

    sw_sm.before_state_t = sw_time_temp;
}


void init_switch () {
    sw_sm.state_t = 0;
    sw_sm.before_state_t = 0;
    sw_sm.deb_timer = 0;
    sw_sm.before_state_s = 0;
    sw_sm.state_s = SWITCH_OFF;
}
